require("showtext")

lf = love.filesystem
ls = love.sound
la = love.audio
lp = love.physics
lt = love.thread
li = love.image
lg = love.graphics

--Schriftarten
font = lg.newFont("fonts/GeosansLight.ttf", 50)
font_big = lg.newFont("fonts/agency.ttf", 80)
font_bigger = lg.newFont("fonts/GeosansLight.ttf", 80)

--Breite/Höhe des Fensters rausfinden
height = love.graphics.getHeight()
width = love.graphics.getWidth()


local _newImage = love.graphics.newImage -- the old function
function love.graphics.newImage(...) -- new function. The ... is to forward any parameters to the old function
	local img = _newImage(...)
	img:setFilter('nearest', 'nearest')
	return img
end		
	
timec = 0

function love.load()

	
	images = {

		icon = lg.newImage("images/icon.png")
		
		
	}
	
	lg.setIcon(images.icon)
	
	timeint = 0
	timegame = 0
	
	score = 0
	
	intro={
	
		bgcolor = {255,255,255,255},
		text="",
		pressed = false
	
	}
	
	game={
	
	state = "intro"
	
	}
	
	player={
	
		width=50,
		height=50,
	
		vel={
		
		x = 0,
		
		y = 0
		
		},
		
		pos={
		
			x=width/2-50/2,
			y=height-200
		
		},
		
		walljump = false
	
	}
	
	camera ={
	
		x = player.pos.x-width/2+player.width/2,
		
		y = 0,
	
	
	
	}
	
	sounds = {
	
		fall = la.newSource("sounds/fall.ogg","static"),
		screenshot = la.newSource("sounds/screenshot.ogg","static"),
		coin = la.newSource("sounds/coin.ogg","static"),
		jump = la.newSource("sounds/jump.ogg","static"),
		power = la.newSource("sounds/power.ogg","static"),
		ende = la.newSource("sounds/end.ogg","static"),
		
		music = la.newSource("sounds/music.ogg","stream")
	
	}
	
	sounds.music:setLooping(true)
	
	love.audio.setVolume(0.3)
	
	
	
	map = {
		
		{x=-100, y=0, w=100, h=height, id="block"}, --left
		{x=0, y=-100, w=5000, h=100, id="block"}, --top
		{x=0, y=height-150, w=8000, h=150, id="block"}, -- bottom
		
		
		{x=300, y=430, w=300, h=50, id="block"},
		{x=800, y=300, w=350, h=50, id="block"},
		{x=900, y=150, w=150, h=50, id="block"},
		
		
		--{x=1400, y=520, w=50, h=50, id="block"},
		--{x=1450, y=470, w=50, h=100, id="block"},
		--{x=1500, y=420, w=50, h=150, id="block"},
		--{x=1550, y=370, w=50, h=200, id="block"},
		{x=1600, y=320, w=50, h=250, id="block"},
		{x=1650, y=270, w=50, h=300, id="block"},
		{x=1700, y=420, w=100, h=50, id="block"},
		
		{x=2000, y=270, w=50, h=50, id="block"},
		{x=2200, y=270, w=50, h=300, id="block"},
		{x=2050, y=0, w=150, h=170, id="block"},
		
		{x=2500, y=400, w=200, h=50, id="block"},
		{x=3000, y=250, w=200, h=50, id="block"},
		{x=3250, y=400, w=400, h=50, id="block"},
		{x=3250, y=400, w=400, h=50, id="block"},
		{x=3550, y=150, w=50, h=50, id="block"},
		{x=3600, y=100, w=50, h=300, id="block"},
		{x=3600, y=60, w=550, h=50, id="block"},
		{x=3800, y=200, w=50, h=400, id="block"},
		{x=3800, y=200, w=350, h=50, id="block"},
		{x=3950, y=350, w=250, h=50, id="block"},
		{x=4100, y=0, w=50, h=60, id="block"},
		{x=4150, y=350, w=50, h=250, id="block"},
		{x=4350, y=250, w=200, h=50, id="block"},
		{x=4650, y=150, w=250, h=50, id="block"},
		{x=4750, y=150, w=50, h=450, id="block"},
		
		
		{x=6000, y=500, w=50, h=50, id="end"},
		
		{x=6500, y=0, w=100, h=720, id="block"},
		
		
		{x=3112.5, y=200, w=25, h=25, id="coin"},
		{x=3012.5, y=200, w=25, h=25, id="coin"},
		{x=3062.5, y=200, w=25, h=25, id="coin"},
		{x=3162.5, y=200, w=25, h=25, id="coin"},
		
		{x=3662.5, y=520, w=25, h=25, id="coin"},
		{x=3662.5, y=250, w=25, h=25, id="coin"}, 
		{x=3762.5, y=400, w=25, h=25, id="coin"},
		{x=3812.5, y=150, w=25, h=25, id="coin"},
		{x=3962.5, y=150, w=25, h=25, id="coin"},
		
		
		{x=3962.5, y=500, w=25, h=25, id="coin"},
		{x=4012.5, y=500, w=25, h=25, id="coin"},
		{x=4062.5, y=500, w=25, h=25, id="coin"},
		{x=4012.5, y=450, w=25, h=25, id="coin"},
		
		{x=362.5, y=392.5, w=25, h=25, id="coin"},
		{x=412.5, y=392.5, w=25, h=25, id="coin"},
		{x=462.5, y=392.5, w=25, h=25, id="coin"},
		{x=512.5, y=392.5, w=25, h=25, id="coin"},
		
		{x=862.5, y=262.5, w=25, h=25, id="coin"},
		{x=962.5, y=262.5, w=25, h=25, id="coin"},
		{x=1062.5, y=262.5, w=25, h=25, id="coin"},
		
		{x=2012.5, y=227.5, w=25, h=25, id="coin"},
		
		{x=962.5, y=100, w=25, h=25, id="supercoin"},
		
		{x=4012.5, y=10, w=40, h=40, id="power"},
	
	}
	
	showtext_tab = {}
	table.insert(showtext_tab, showtext:create(height/7, "you are 'Cube'", 0, 2, {150,255,0,255},""))
	table.insert(showtext_tab, showtext:create(height/4, "also you can move left by pressing left or 'a'", 3, 5, {150,255,0,255},false))
	table.insert(showtext_tab, showtext:create(height/3, "and move right by pressing right or 'd'", 3, 5, {150,255,0,255},false))
	table.insert(showtext_tab, showtext:create(height/7, "you can jump with space or 'w'", 3, 5, {150,255,0,255},false))
	table.insert(showtext_tab, showtext:create(height-100, "<- Exit", 3, 5, {150,255,0,255},false,50))
	table.insert(showtext_tab, showtext:create(height-100, "Start Adventure ->", 3, 5, {150,255,0,255},false,width-font:getWidth("Start Adventure ->")-50))
end

function love.focus(f)



end

function love.mousepressed(x,y,button)



end

function love.keypressed(k)

	if k=="f12" then
		saveScreenshot()
		love.audio.play(sounds.screenshot)
	end
	
	if k == "escape" then
		love.event.quit()
	end
	
	if game.state == "intro" and timec>0 then
		game.state = "introduction"
		intro.pressed = true
		lg.setBackgroundColor(255,255,255,255)
		love.audio.play(sounds.music)
	end
	
	
	if game.state == "introduction" then
	
		for i,v in ipairs(showtext_tab) do
			showtext_tab[i]:test(k)
		end
		
	
	end

end

function love.keyreleased(k)

	if game.state == "introduction" then
		intro.pressed = false
	end

end

function love.joystickpressed()



end

function love.update(dt)
	
	timec = timec + dt
	
	dt = math.min(dt,0.03)
	
	if game.state == "intro" then
		if timec<1 then
			intro.bgcolor = {255,100,0,255}
			intro.text = "BE"
		elseif timec<2 then
			intro.bgcolor = {150,255,0,255}
			intro.text = "BE A"
		else
			intro.bgcolor = {0,150,255,255}
			intro.text = "BE A CUBE"
		end	
	end
	
	if game.state == "introduction" then
	
		timeint = timeint + dt
	
		if (love.keyboard.isDown("left") or love.keyboard.isDown("a")) and not love.keyboard.isDown("right") and not love.keyboard.isDown("d") then
			
			if player.vel.x > -400 then
				player.vel.x = player.vel.x-1200*dt
			end
			
		elseif (love.keyboard.isDown("right") or love.keyboard.isDown("d")) and not love.keyboard.isDown("left") and not love.keyboard.isDown("a") then

			if player.vel.x < 400 then
				player.vel.x = player.vel.x+1200*dt
			end
		
		else
			if player.vel.x > 2 then
				player.vel.x = player.vel.x - 1200*dt
			elseif player.vel.x < -2 then
				player.vel.x = player.vel.x + 1200*dt
			else
				player.vel.x = 0
			end
		end
		
		player.pos.x = player.pos.x + player.vel.x*dt
		if player.pos.y + player.vel.y*dt < 720-200 then
			player.pos.y = player.pos.y + player.vel.y*dt
			standing = false

		else
			standing=true

		end
			
		if player.pos.x > width then
			game.state = "game"
			player.pos.x = 0
		end
		
		if player.pos.x < -player.width then
			love.event.quit()
		end
		
		if (love.keyboard.isDown(" ") or love.keyboard.isDown("w")) and intro.pressed == false and standing then
				player.vel.y = -600
				love.audio.play(sounds.jump)
		end
		
		player.vel.y = player.vel.y + 1000 * dt
		
		for i,v in ipairs(showtext_tab) do
			showtext_tab[i]:update(dt, timeint)
		end
		
		
		
	end
	
	if game.state == "game" then
	
		timegame = timegame + dt

		camera.x = player.pos.x-width/2+player.width/2
		
		if camera.x < 0 then camera.x = 0 end
		
		if camera.x > 5250 then camera.x = 5250 end
	
		if (love.keyboard.isDown("left") or love.keyboard.isDown("a")) and not love.keyboard.isDown("right") and not love.keyboard.isDown("d") then
			
			if player.vel.x > -400 then
				player.vel.x = player.vel.x-1500*dt
			end
			
		elseif (love.keyboard.isDown("right") or love.keyboard.isDown("d")) and not love.keyboard.isDown("left") and not love.keyboard.isDown("a") then

			if player.vel.x < 400 then
				player.vel.x = player.vel.x+1500*dt
			end
		
		else
			if player.vel.x > 2 then
				player.vel.x = player.vel.x - 1500*dt
			elseif player.vel.x < -2 then
				player.vel.x = player.vel.x + 1500*dt
			else
				player.vel.x = 0
			end
		end
		
		
		
		local newx = player.pos.x + player.vel.x*dt	
		local newy = player.pos.y + player.vel.y*dt	
		
		local collide = {x=false, y=false}
		local onWool = {left=false, right=false}
		
		local standing = false
		
		for i,v in ipairs(map) do 
		
			local col = collisionDetect(player.pos.x, player.pos.y,newx,newy,v)	
		
			if v.id == "coin" and (col.l or col.r or col.t or col.b) then
				
				table.remove(map, i)
				score = score + 1
				love.audio.play(sounds.coin)
				
			elseif v.id == "power" and (col.l or col.r or col.t or col.b) then
			
				table.remove(map, i)
				love.audio.play(sounds.power)
				player.walljump = true
				
				walljump = showtext:create(100, "now you can walljump", 3, 5, {150,255,0,255},"",width/2-font_bigger:getWidth("now you can walljump")/2,true)
			
			elseif v.id == "supercoin" and (col.l or col.r or col.t or col.b) then
					
				table.remove(map, i)
				score = score + 5
				love.audio.play(sounds.coin)
			
			
			elseif v.id == "end" and (col.l or col.r or col.t or col.b) then
			
				table.remove(map, i)
				love.audio.play(sounds.ende)
				game.state = "end"
			
			else
			
				if col.l or col.r then collide.x = true player.vel.x = 0 end
				if col.t or col.b then 
					collide.y = true player.vel.y = 0 
				end
				if col.b then standing = true player.pos.y = v.y-player.width-0.001 end
				if col.l then onWool.left = true player.pos.x = v.x-player.width-0.001 end
				if col.r then onWool.right = true player.pos.x = v.x+v.w+0.001 end
				if col.t then player.pos.y = v.y+v.h+0.001 end
				
			end
		
		end
		
		if onWool.left and player.walljump then 
			standing = true
		end
		
		if onWool.right and player.walljump then
			standing = true
		end

		
		if (love.keyboard.isDown(" ") or love.keyboard.isDown("w")) and intro.pressed == false and standing then
			player.vel.y = -600
		
			if onWool.left and player.walljump then 
				player.vel.x = -400
			end
			
			if onWool.right and player.walljump then
				player.vel.x = 400
			end

			love.audio.play(sounds.jump)
		end
		
		if not collide.x then
			player.pos.x = newx
		end
		
		if not collide.y then
			player.pos.y = newy
		end
		
		player.vel.y = player.vel.y + 1000 * dt
		
		if player.walljump then
			walljump:update(dt, timeint)
		end
	end
	
	
	if game.state == "end" then
	
		
	
	end

end

function love.draw()

	lg.setFont(font_big)
	
	if game.state == "intro" then
		lg.setBackgroundColor(intro.bgcolor)
		lg.setColor(255,255,255,255)
		lg.print(intro.text, width/2-font_big:getWidth("BE A CUBE")/2, height/2-font_big:getHeight()/2)
		if timec > 3 then
			lg.setColor(255,255,255,math.floor(math.abs(math.sin(timec+3.5)*255)))
			lg.setFont(font)
			lg.print("press any key", width/2-font:getWidth("press any key")/2, height*3/4)
		end
	end
	
	if game.state == "introduction" then
		
	
		lg.setColor(math.floor((1.0+math.sin(timec))*122.5),math.floor(math.abs(math.sin(timec))*255),math.floor(math.abs(math.cos(timec))*255),255)
		lg.rectangle("fill", player.pos.x, player.pos.y, player.width, player.height)
		
		lg.setColor(191,255,128,255)
		lg.rectangle("fill", 0, height-150 , width, 150)
		
		for i,v in ipairs(showtext_tab) do
			showtext_tab[i]:draw()
		end
		--	lg.print("You are 'Cube'", width/2-font_big:getWidth("You are 'Cube'")/2, height/5)
			

		
	end
	
	if game.state == "game" then
		
		lg.setColor(math.floor((1.0+math.sin(timec))*122.5),math.floor(math.abs(math.sin(timec))*255),math.floor(math.abs(math.cos(timec))*255),255)
		lg.rectangle("fill", player.pos.x-camera.x, player.pos.y, player.width, player.height)
	
		
	
		for i,v in ipairs(map) do 
		
			if v.id == "block" then
				lg.setColor(191,255,128,255)
				lg.rectangle("fill", v.x-camera.x, v.y, v.w, v.h)
			end
			
			if v.id == "coin" then
			
				lg.setColor(255,255,0,255)
				
				love.graphics.translate(v.x-camera.x+12.5, v.y+12.5+math.sin(timec*2)*5)
				love.graphics.rotate(timec)
				love.graphics.translate(-(v.x-camera.x+12.5), -(v.y+12.5+math.sin(timec*2)*5))
				
				lg.rectangle("fill", v.x-camera.x, v.y+math.sin(timec*2)*5, v.w, v.h)
				
				
				love.graphics.translate(v.x-camera.x+12.5, v.y+12.5+math.sin(timec*2)*5)
				love.graphics.rotate(-timec)
				love.graphics.translate(-(v.x-camera.x+12.5), -(v.y+12.5+math.sin(timec*2)*5))
			
			end
			
			if v.id == "power" then
				lg.setColor(0,222,255,255)
				lg.circle("fill", v.x-camera.x+v.w/2, v.y+v.w/2, v.w/2)
			end
			
			if v.id == "supercoin" then
			
				lg.setColor(255,0,255,255)
				
				love.graphics.translate(v.x-camera.x+12.5, v.y+12.5+math.sin(timec*2)*5)
				love.graphics.rotate(timec)
				love.graphics.translate(-(v.x-camera.x+12.5), -(v.y+12.5+math.sin(timec*2)*5))
				
				lg.rectangle("fill", v.x-camera.x, v.y+math.sin(timec*2)*5, v.w, v.h)
				
				
				love.graphics.translate(v.x-camera.x+12.5, v.y+12.5+math.sin(timec*2)*5)
				love.graphics.rotate(-timec)
				love.graphics.translate(-(v.x-camera.x+12.5), -(v.y+12.5+math.sin(timec*2)*5))
			
			end
			
			
			if v.id == "end" then
			
				
				lg.setColor(255,0,0,255)
				
			
				lg.rectangle("fill", v.x-camera.x, v.y+math.sin(timec*2)*5, v.w, v.h)		
				
			
			end
			
		end
		
		lg.setFont(font)
		lg.setColor(255,175,0,255)
		lg.print("Score: "..score, 50,0)
	
		if player.walljump then
			
			walljump:draw()
			
		end
	
	end
	
	
	if game.state == "end" then
		
		lg.setColor(math.floor((1.0+math.sin(timec))*122.5),math.floor(math.abs(math.sin(timec))*255),math.floor(math.abs(math.cos(timec))*255),255)
		lg.rectangle("fill", width/2-125, height/3-125, 250, 250)
		
		lg.setFont(font_bigger)
		lg.print("Victory!", width/2-font_bigger:getWidth("Victory!")/2, height/2)
		
		lg.setFont(font)
		lg.print("Your Score: "..score, width/2-font:getWidth("Your Score: "..score)/2, height-height/3)
		lg.print("Your Time: "..math.floor(timegame).." Seconds", width/2-font:getWidth("Your Time: "..math.floor(timegame).." Seconds")/2, height*9/12)
		
		lg.print("press 'ESC' to exit", width/2-font:getWidth("press 'ESC' to exit")/2, height-100)
	end

	
end

function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function saveScreenshot()
  local name = string.format("screenshot-%s.png", os.date("%Y%m%d-%H%M%S"))
  local shot = lg.newScreenshot()
  shot:encode(name, "png")
end

function collisionDetect(x1,y1,x2,y2,v)



	
		local cleft = x1 + player.width <= v.x and x2 + player.width >= v.x
		local cright = x1 >= v.x + v.w and x2 <= v.x + v.w
		local ctop = y1 >= v.y + v.h and y2 <= v.y + v.h
		local cbottom = y1 + player.height <= v.y and y2 + player.height >= v.y

		local oy = y1 + player.height >= v.y and y1 <= v.y + v.h
		local ox = x1 + player.width >= v.x and x1 <= v.x + v.w
		local collide = {l= false, r= false, t= false, b= false}

		if(cleft and oy) then
			collide.l = true
		end
		
		if(cright and oy) then
			collide.r = true
		end
		
		if(ctop and ox) then
			collide.t = true
		end
		
		if(cbottom and ox) then
			collide.b = true
		end

		return collide


end