showtext = {}

function showtext:create(y, text, start, duration, color, cond, x, sn)
o = {}
o.y = y

if x then
	o.x = x
else
	o.x = width/2-font:getWidth(text)/2
end

o.text = text
o.start = start
o.duration = duration
o.color = color
o.show = false
o.alpha = 0
o.cond = cond
o.goal = false
o.sn = sn
o.time = 0

setmetatable(o, self)
self.__index = self
return o
end

function showtext:update(dt, timeint)

	if (self.start+self.duration)<timeint and (self.cond=="" or self.goal) and not self.sn then
	
		self.alpha = self.alpha - 1 * dt
		if self.alpha < 0 then
			self.show = false
			self.sn = false
		end
		
	elseif self.start<timeint and not self.sn then
	
		self.show = true
		
		if self.alpha<1 then
			self.alpha = self.alpha + 1 * dt
		end
		
	end
	
	if self.sn then
		self.show = true
		self.time = self.time + dt
		
		if self.time>self.duration then
		
			self.alpha = self.alpha - 1 * dt
			
			if self.alpha < 0 then
				self.show = false
				self.sn = false
			end
		
		elseif self.alpha<1 then
			self.alpha = self.alpha + 1 * dt
		end
		
	end

end

function showtext:draw()

	if self.show then
	
		if self.sn then
			lg.setFont(font_bigger)
		else
			lg.setFont(font)
		end
		
		lg.setColor(0,90,255,self.alpha*255)
		
		lg.print(self.text, self.x, self.y)
	end

end

function showtext:test(k)

	if k == self.cond and self.show then
		self.goal = true
	end

end